<template>
    <ion-grid>
        <ion-row v-for="curPort in curPortList" :key="curPort.id">
            <ion-col
                ><ion-input
                    label-placement="floating"
                    fill="solid"
                    v-model="curPort.hubPort"
                    aria-label="Port na HUBu"
                    label="Port na HUBu"
                    placeholder="Port na HUBu"
                    type="number"
                ></ion-input
            ></ion-col>

            <ion-col
                ><ion-input
                    label-placement="floating"
                    fill="solid"
                    v-model="curPort.devicePort"
                    aria-label="Port na zařízení"
                    label="Port na zařízení"
                    placeholder="Port na zařízení"
                    type="number"
                ></ion-input
            ></ion-col>

            <ion-col>
                <ion-datetime-button
                    :datetime="'port' + curPort.id"
                ></ion-datetime-button>

                <ion-modal :keep-contents-mounted="true">
                    <ion-datetime
                        max="2099-12-31T23:59:59"
                        v-model="curPort.expiration"
                        :id="'port' + curPort.id"
                        ><span slot="title">Expirace portu</span></ion-datetime
                    >
                </ion-modal>
            </ion-col>
            <ion-col>
                <ion-button
                    color="danger"
                    shape="round"
                    @click="removeFromList(curPort.id)"
                    ><ion-icon slot="icon-only" :icon="remove"></ion-icon
                ></ion-button>
            </ion-col>
        </ion-row>

        <ion-row>
            <ion-col>
                <ion-button color="success" shape="round" @click="newDefault"
                    ><ion-icon slot="icon-only" :icon="add"></ion-icon
                ></ion-button>
            </ion-col>
        </ion-row>
    </ion-grid>
</template>

<script setup lang="ts">
import { CreateDevicePortFromDevice } from '@/gql/graphql'
import { add, remove } from 'ionicons/icons'
import {
    IonButton,
    IonDatetime,
    IonDatetimeButton,
    IonModal,
    IonInput,
    IonCol,
    IonGrid,
    IonRow,
    IonIcon,
} from '@ionic/vue'

const curPortList = defineModel<
    ({ id: number | string } & CreateDevicePortFromDevice)[]
>({ required: true })

const now = new Date()
now.setSeconds(0)
now.setMinutes(0)
now.setHours(0)

const newDefault = () => {
    let max = 0

    curPortList.value.forEach((val) => {
        if (Number(val.id) > max) {
            max = Number(val.id)
        }
    })

    const empty = {
        id: max + 1,
        hubPort: '',
        devicePort: '',
        expiration: now.toISOString(),
        added: true,
    }

    curPortList.value = [...curPortList.value, empty]
}

const removeFromList = (id: number | string) => {
    curPortList.value = curPortList.value.filter(
        (item: { id: number | string } & CreateDevicePortFromDevice) =>
            item.id !== id
    )
}
</script>
